/*##############################################################################

    HPCC SYSTEMS software Copyright (C) 2012 HPCC Systems.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
############################################################################## */

#pragma warning (disable : 4786)

#include "ecldirect_esp.ipp"
#include "http/platform/httpprot.hpp"
#include "EclDirectService.hpp"
#include "espplugin.hpp"

extern "C"
{

ESP_FACTORY IEspService * esp_service_factory(const char *name, const char* type, IPropertyTree *cfg, const char *process)
{
   if (strcmp(type, "EclDirect")==0)
   {
      CEclDirectEx* service = new CEclDirectEx();
        service->init(cfg, process, name);
      return service;
   }

   ERRLOG("Unknown service type %s", type);
   return NULL;
}

ESP_FACTORY IEspRpcBinding * esp_binding_factory(const char *name, const char* type, IPropertyTree *cfg, const char *process)
{
   if (strcmp(type, "EclDirectSoapBinding")==0)
        return new CEclDirectSoapBindingEx(cfg, name, process);

   ERRLOG("Unknown binding type %s", type);
   return NULL;
}

ESP_FACTORY IEspProtocol * esp_protocol_factory(const char *name, const char* type, IPropertyTree *cfg, const char *process)
{
    if (strcmp(type, "http_protocol")==0)
        return new CHttpProtocol;

    if(strcmp(type, "secure_http_protocol") == 0)
    {
        IPropertyTree *sslSettings;
        sslSettings = cfg->getPropTree(StringBuffer("Software/EspProcess[@name=\"").append(process).append("\"]").append("/EspProtocol[@name=\"").append(name).append("\"]").str());
        if(sslSettings != NULL)
            return new CSecureHttpProtocol(sslSettings);
        ERRLOG("can't find ssl settings in the config file");
        return NULL;
    }

    ERRLOG("Unknown protocol %s", name);
    return NULL;
}

};
